#!/bin/sh

DATAFILE1=$1
DATAFILE2=$2
DATAFILE3=$3
IMGFILE=$4
TITLE=$5
KEY=$6
HEIGHT=$7
WIDTH=$8

gnuplot <<EOF
set terminal postscript enhanced eps color
set output "${IMGFILE}"
set size ${WIDTH},${HEIGHT}
set key ${KEY}
set rmargin 3

set title "${TITLE}"
set xlabel "Tamanho do bloco"
set ylabel "Duracao (ms)"
set pointsize 0.7


set xtics (        \
  "..." 64,      \
  "" 128,          \
  "" 256,          \
  "" 512,          \
  "" 1024,         \
  "" 2048,         \
  "" 4096,   \
  "" 8192,   \
  "2^{14}" 16384,  \
  "2^{15}" 32768,  \
  "2^{16}" 65536,  \
  "2^{17}" 131072, \
  "2^{18}" 262144 )
set grid

set yrange [0:0.5]
set xrange [64:131072]
#set log x 2
#set log y 2

plot "${DATAFILE1}" using 1:2 title "FFT: hosp. p/ disp." with linespoints lt 0 lc 0 pt 7 lw 3, \
     "${DATAFILE1}" using 1:4 title "FFT: disp. p/ hosp." with linespoints lt 6 lc 0 pt 7 lw 3, \
     "${DATAFILE2}" using 1:2 title "convolution: hosp. p/ disp." with linespoints lt 0 lc 1 pt 7 lw 3, \
     "${DATAFILE2}" using 1:4 title "convolution: disp. p/ hosp." with linespoints lt 6 lc 1 pt 7 lw 3, \
     "${DATAFILE3}" using 1:2 title "PV: hosp. p/ disp." with linespoints lt 0 lc 3 pt 7 lw 3, \
     "${DATAFILE3}" using 1:4 title "PV: disp. p/ hosp." with linespoints lt 6 lc 3 pt 7 lw 3

EOF
