#!/bin/sh

DATAFILE=$1
IMGFILE=$2
TITLE=$3
KEY=$4
HEIGHT=${5}
WIDTH=${6}
RMARGIN=${7}

gnuplot <<EOF
set terminal postscript enhanced eps color
set output "${IMGFILE}"
set size ${WIDTH},${HEIGHT}
set key ${KEY}
set rmargin ${RMARGIN}
set pointsize 0.7

set title "Convolution roundtrip time - ${TITLE}"
set xlabel "Block size"
set ylabel "Duration (s)"

set xtics (        \
  "..." 64,      \
  "" 128,          \
  "" 256,          \
  "" 512,          \
  "" 1024,         \
  "" 2048,         \
  "" 4096,   \
  "" 8192,   \
  "2^{14}" 16384,  \
  "2^{15}" 32768,  \
  "2^{16}" 65536,  \
  "2^{17}" 131072, \
  "2^{18}" 262144 )
set grid

set ytics (     \
  "5" 5000,     \
  "10" 10000,   \
  "15" 15000,   \
  "20" 20000,   \
  "25" 25000,   \
  "30" 30000 )
#  "2" 2000,    \
#  "4" 4000,    \
#  "6" 6000,    \
#  "8" 8000,    \
#  "10" 10000,  \
#  "12" 12000,  \
#  "14" 14000,  \
#  "16" 16000,  \
#  "18" 18000,  \
#  "20" 20000 )

set yrange [0:30000]
set xrange [0:131072]
#set log x 2

plot "${DATAFILE}" using 1:2 title "host to device" with linespoints pt 7  lc 0 lw 3 lt 8, \
     "${DATAFILE}" using 1:3 title "kernel time" with linespoints pt 7  lt 1 lc 3 lw 3, \
     "${DATAFILE}" using 1:4 title "device to host" with linespoints pt 7  lt 6 lc 1 lw 3, \
     "${DATAFILE}" using 1:(column(2)+column(3)+column(4)) title "roundtrip" with linespoints pt 7  lt 1 lc 8 lw 3, \
     "${DATAFILE}" using 1:(column(1)/44.100) title "rt period" with lines lt 3 lc 0 lw 4
EOF
