#!/bin/sh

DATAFILE=$1
IMGFILE=$2
TITLE=$3
KEY=$4
HEIGHT=${5}
WIDTH=${6}
RMARGIN=${7}

gnuplot <<EOF
set terminal postscript enhanced eps color
set output "../img/CONV-all.eps"
#set size 0.5,0.5
#set key off
set key below vertical
set size 0.5,0.64
set rmargin 3
set pointsize 0.7

set title "Tempo de convolucao - todas as placas"
set xlabel "Periodo do bloco (s)"
set ylabel "Duracao (s)"

set xtics (        \
  "..." 64,      \
  "" 128,          \
  "" 256,          \
  "" 512,          \
  "" 1024,         \
  "" 2048,         \
  "" 4096,   \
  "" 8192,   \
  "0,37" 16384,  \
  "0,74" 32768,  \
  "1,48" 65536,  \
  "2,97" 131072, \
  "2^{18}" 262144 )
set grid

set ytics (     \
  "2" 2000,     \
  "4" 4000,     \
  "6" 6000,     \
  "8" 8000,     \
  "10" 10000,   \
  "15" 15000,   \
  "20" 20000,   \
  "25" 25000,   \
  "30" 30000 )
#  "2" 2000,    \
#  "4" 4000,    \
#  "6" 6000,    \
#  "8" 8000,    \
#  "10" 10000,  \
#  "12" 12000,  \
#  "14" 14000,  \
#  "16" 16000,  \
#  "18" 18000,  \
#  "20" 20000 )

set yrange [0:10000]
set xrange [0:131072]
#set log x 2

plot "../roundtrip/CONV-275-batch.txt" using 1:3 title "GTX275" with linespoints pt 7 lc 1 lw 3 lt 1, \
     "../roundtrip/CONV-470-batch.txt" using 1:3 title "GTX470" with linespoints pt 7 lt 1 lc 0 lw 3, \
     "../roundtrip/CONV-4000-batch.txt" using 1:3 title "GF100GL" with linespoints pt 7 lt 1 lc 3 lw 3, \
     "../roundtrip/CONV-275-batch.txt" using 1:(column(1)/44.100) title "restricao de tempo real" with lines lt 3 lc 0 lw 4










set output "../img/CONV-all-zoom.eps"
set title "Tempo de convolucao (zoom) - todas as placas"

set yrange [0:1000]
set xrange [0:32768]
#set log x 2

set xtics (        \
  "..." 64,      \
  "" 128,          \
  "" 256,          \
  "" 512,          \
  "" 1024,         \
  "" 2048,         \
  "2^{12}" 4096,   \
  "2^{13}" 8192,   \
  "2^{14}" 16384,  \
  "2^{15}" 32768,  \
  "2^{16}" 65536,  \
  "2^{17}" 131072, \
  "2^{18}" 262144 )
set ytics (     \
  "0.2" 200,     \
  "0.4" 400,     \
  "0.6" 600,     \
  "0.8" 800,     \
  "1" 10000,   \
  "30" 30000 )

set key above vertical
set size 0.5,0.64

plot "../roundtrip/CONV-275-batch.txt" using 1:3 title "GTX275" with linespoints pt 7 lc 1 lw 3 lt 1, \
     "../roundtrip/CONV-470-batch.txt" using 1:3 title "GTX470" with linespoints pt 7 lt 1 lc 0 lw 3, \
     "../roundtrip/CONV-4000-batch.txt" using 1:3 title "GF100GL" with linespoints pt 7 lt 1 lc 3 lw 3, \
     "../roundtrip/CONV-275-batch.txt" using 1:(column(1)/44.100) title "rt period" with lines lt 3 lc 0 lw 4

EOF

