#!/bin/sh

DATAFILE=$1
IMGFILE=$2
TITLE=$3

gnuplot <<EOF
set terminal postscript enhanced eps color
set output "${IMGFILE}"
set size 0.5,0.65
set key below
set rmargin 3
set pointsize 1.4

set title "Convolution roundtrip time - GTX ${TITLE}"
set xlabel "Block size"
set ylabel "Duration (ms)"

set xtics (        \
  "..." 64,      \
  "" 128,          \
  "" 256,          \
  "" 512,          \
  "" 1024,         \
  "" 2048,         \
  "0,09" 4096,   \
  "0,18" 8192,   \
  "0,37" 16384,  \
  "0,74" 32768,  \
  "1,48" 65536,  \
  "2,97" 131072, \
  "2^{18}" 262144 )
set grid

set yrange [0:30000]
set xrange [0:131072]
#set log x 2

plot "${DATAFILE}" using 1:2 title "host to device" with lines ls 1 lc 0 lw 2, \
     "${DATAFILE}" using 1:3 title "kernel time" with lines ls 1 lc 1 lw 2, \
     "${DATAFILE}" using 1:4 title "device to host" with lines ls 1 lc 3 lw 2, \
     "${DATAFILE}" using 1:(column(2)+column(3)+column(4)) title "roundtrip" with lines ls 1 lc 8 lw 2, \
     "${DATAFILE}" using 1:(column(1)/44100.0) title "dsp period" with lines ls 0 lc 0 lw 4
EOF
