#!/bin/sh

DATAFILE=$1
IMGFILE=$2
TITLE=$3
KEY=$4
HEIGHT=${5}
WIDTH=${6}
RMARGIN=${7}

gnuplot <<EOF
set terminal postscript enhanced eps color
set output "${IMGFILE}"
set size ${WIDTH},${HEIGHT}
set key ${KEY}
set rmargin ${RMARGIN}
set pointsize 0.7

set title "Tempo de roundtrip da FFT - ${TITLE}"
set xlabel "Periodo do bloco (s)"
set ylabel "Duracao (s)"

set xtics (        \
  "..." 64,      \
  "" 128,          \
  "" 256,          \
  "" 512,          \
  "" 1024,         \
  "" 2048,         \
  "" 4096,   \
  "" 8192,   \
  "0,37" 16384,  \
  "0,74" 32768,  \
  "1,48" 65536,  \
  "2,97" 131072, \
  "2^{18}" 262144 )
set grid

set yrange [0:3]
set xrange [0:131072]
#set log x 2

plot "${DATAFILE}" using 1:2 title "hospedeiro para dispositivo" with linespoints pt 7  lc 0 lw 3 lt 8, \
     "${DATAFILE}" using 1:3 title "tempo de kernel" with linespoints pt 7  lt 1 lc 3 lw 3, \
     "${DATAFILE}" using 1:4 title "dispositivo para hospedeiro" with linespoints pt 7  lt 6 lc 1 lw 3, \
     "${DATAFILE}" using 1:(column(2)+column(3)+column(4)) title "roundtrip" with linespoints pt 7  lt 1 lc 8 lw 3, \
     "${DATAFILE}" using 1:(column(1)/44100.0) title "restricao de tempo real" with lines lt 3 lc 0 lw 4
EOF
