#!/bin/sh

DATAFILE1=$1
DATAFILE2=$2
DATAFILE3=$3
DATAFILE4=$4
DATAFILE5=$5
DATAFILE6=$6
IMGFILE=$7
MODEL=$8
KEY=$9
HEIGHT=${10}

gnuplot <<EOF
set terminal postscript enhanced eps color
set output "${IMGFILE}"
set size 0.5,${HEIGHT}
set rmargin 3
set pointsize 0.7
set key ${KEY}

set title "Tempo de sintese do PV - ${MODEL}"
set xlabel "Periodo do bloco (s)"
set ylabel "Duracao (s)"


set xtics (        \
  "" 64,      \
  "" 128,          \
  "" 256,          \
  "" 512,          \
  "" 1024,         \
  "" 2048,         \
  "..." 4096,   \
  "" 8192,   \
  "0,37" 16384,  \
  "0,74" 32768,  \
  "1,48" 65536,  \
  "2,97" 131072, \
  "2^{18}" 262144 )

set ytics (     \
  "5" 5000,     \
  "10" 10000,   \
  "15" 15000,   \
  "20" 20000,   \
  "25" 25000,   \
  "30" 30000 )
#  "2" 2000,    \
#  "4" 4000,    \
#  "6" 6000,    \
#  "8" 8000,    \
#  "10" 10000,  \
#  "12" 12000,  \
#  "14" 14000,  \
#  "16" 16000,  \
#  "18" 18000,  \
#  "20" 20000 )
set grid

set yrange [0:30000]
set xrange [64:131072]

plot "${DATAFILE3}" using 1:3 title "1. interpolacao cubica" with linespoints lc 0 lt 8 lw 3 pt 7, \
     "${DATAFILE2}" using 1:3 title "2. interpolacao linear" with linespoints lc 1 lt 6 lw 3 pt 7, \
     "${DATAFILE1}" using 1:3 title "3. consulta truncada" with linespoints lc 3 lt 1 lw 3 pt 7, \
     "${DATAFILE4}" using 1:3 title "4. funcao seno" with linespoints lc 8 lt 1 lw 3 pt 7,\
     "${DATAFILE6}" using 1:3 title "5. interpolacao de textura" with linespoints lc 9 lt 12 lw 3 pt 7,\
     "${DATAFILE5}" using 1:3 title "sem calculo" with linespoints lc 0 lt 0 lw 4 pt 7, \
     "${DATAFILE1}" using 1:(column(1)/44.100) title "restricao de tempo real" with lines lt 3 lc 0 lw 4
EOF
