#!/bin/sh

DATAFILE1=$1
DATAFILE2=$2
IMGFILE=$3
TITLE=$4

gnuplot <<EOF
set terminal postscript enhanced eps monochrome
set output "${IMGFILE}"
set size 0.5,0.5
set key left top
set rmargin 3

set title "${TITLE}"
set xlabel "Block size"
set ylabel "Duration (ms)"


set xtics (        \
  "..." 64,      \
  "" 128,          \
  "" 256,          \
  "" 512,          \
  "" 1024,         \
  "" 2048,         \
  "" 4096,   \
  "" 8192,   \
  "2^{14}" 16384,  \
  "2^{15}" 32768,  \
  "2^{16}" 65536,  \
  "2^{17}" 131072, \
  "2^{18}" 262144 )
set grid

set yrange [0:0.25]
set xrange [64:131072]
#set log x 2
#set log y 2

plot "${DATAFILE1}" using 1:2 title "FFT: host to device" with linespoints ls 8, \
     "${DATAFILE1}" using 1:4 title "FFT: device to host" with linespoints ls 10, \
     "${DATAFILE2}" using 1:2 title "PV: host to device" with linespoints ls 9, \
     "${DATAFILE2}" using 1:4 title "PV: device to host" with linespoints ls 11

EOF
