#!/bin/sh

DATAFILE=$1
IMGFILE=$2
TITLE=$3

gnuplot <<EOF
set terminal postscript enhanced eps monochrome
set output "${IMGFILE}"
set size 0.5,0.5
set key left top
set rmargin 3
set pointsize 1.4

set title "FFT times - GTX ${TITLE}"
set xlabel "Block size"
set ylabel "Duration (ms)"

set xtics (        \
  "..." 64,      \
  "" 128,          \
  "" 256,          \
  "" 512,          \
  "" 1024,         \
  "" 2048,         \
  "" 4096,   \
  "" 8192,   \
  "2^{14}" 16384,  \
  "2^{15}" 32768,  \
  "2^{16}" 65536,  \
  "2^{17}" 131072, \
  "2^{18}" 262144 )
set grid

set yrange [0:0.6]
set xrange [0:131072]
#set log x 2

plot "${DATAFILE}" using 1:2 title "host to device" with linespoints ls 8 lw 2, \
     "${DATAFILE}" using 1:3 title "kernel time" with linespoints ls 4 lw 2, \
     "${DATAFILE}" using 1:4 title "device to host" with linespoints ls 10 lw 2, \
     "${DATAFILE}" using 1:(column(2)+column(3)+column(4)) title "roundtrip" with linespoints ls 12 lw 2
EOF
