#!/bin/sh

DATAFILE1=$1
DATAFILE2=$2
DATAFILE3=$3
DATAFILE4=$4
DATAFILE5=$5
DATAFILE6=$6
IMGFILE=$7
MODEL=$8
KEY=$9
HEIGHT=${10}

gnuplot <<EOF
set terminal postscript enhanced eps monochrome
set output "${IMGFILE}"
set size 0.5,${HEIGHT}
#set key left top
#set key below vertical
set key ${KEY}
set rmargin 3
set pointsize 1.4

set title "PV synth kernel time - GTX  ${MODEL}"
set xlabel "Block size"
set ylabel "Duration (s)"


set xtics (        \
  "..." 64,      \
  "" 128,          \
  "" 256,          \
  "" 512,          \
  "" 1024,         \
  "" 2048,         \
  "" 4096,   \
  "" 8192,   \
  "2^{14}" 16384,  \
  "2^{15}" 32768,  \
  "2^{16}" 65536,  \
  "2^{17}" 131072, \
  "2^{18}" 262144 )

set ytics (     \
  "1" 1000,     \
  "2" 2000,     \
  "3" 3000,     \
  "4" 4000,     \
  "5" 5000,     \
  "10" 10000,   \
  "15" 15000,   \
  "20" 20000 )
#  "2" 2000,    \
#  "4" 4000,    \
#  "6" 6000,    \
#  "8" 8000,    \
#  "10" 10000,  \
#  "12" 12000,  \
#  "14" 14000,  \
#  "16" 16000,  \
#  "18" 18000,  \
#  "20" 20000 )
set grid

set yrange [0:3000]
#set xrange [64:131072]
set xrange [16384:98304]
#set log x 2
#set log y 2

plot "../roundtrip/block-period.txt" using 1:2 title "block period" with linespoints ls -1, \
     "${DATAFILE3}" using 1:3 title "1. cubic interp" with linespoints ls 8 lw 3, \
     "${DATAFILE2}" using 1:3 title "2. linear interp" with linespoints ls 6 lw 3, \
     "${DATAFILE1}" using 1:3 title "3. truncated" with linespoints ls 4 lw 3, \
     "${DATAFILE4}" using 1:3 title "4. builtin sine" with linespoints ls 10 lt 2 lw 3,\
     "${DATAFILE6}" using 1:3 title "5. texture interp" with linespoints ls 12 lw 3,\
     "${DATAFILE5}" using 1:3 title "no calculation" with linespoints ls 0 lw 3

EOF
