#!/bin/sh

DATAFILE1=$1
DATAFILE2=$2
DATAFILE3=$3
DATAFILE4=$4
DATAFILE5=$5
DATAFILE6=$6
IMGFILE=$7
MODEL=$8

gnuplot <<EOF
set terminal postscript enhanced eps monochrome
set output "${IMGFILE}"
set size 0.5,0.5
set key left top
set rmargin 3

set title "PV synth kernel time (1) - GTX ${MODEL}"
set xlabel "Block size"
set ylabel "Duration (s)"


set xtics (        \
  "..." 64,        \
  "" 128,          \
  "" 256,          \
  "" 512,          \
  "" 1024,         \
  "" 2048,         \
  "2^{12}" 4096,   \
  "2^{13}" 8192,   \
  "2^{14}" 16384,  \
  "2^{15}" 32768,  \
  "2^{16}" 65536,  \
  "2^{17}" 131072, \
  "2^{18}" 262144 )

set ytics (  \
  "0.2" 200, \
  "0.4" 400, \
  "0.6" 600, \
  "0.8" 800, \
  "1" 1000 )
set grid

set yrange [0:1000]
set xrange [64:32768]
#set log x 2
#set log y 2

plot "../roundtrip/block-period.txt" using 1:2 title "block period" with linespoints ls -1, \
     "${DATAFILE3}" using 1:3 title "1. cubic interp" with linespoints ls 8, \
     "${DATAFILE2}" using 1:3 title "2. linear interp" with linespoints ls 6, \
     "${DATAFILE1}" using 1:3 title "3. truncated" with linespoints ls 4, \
     "${DATAFILE4}" using 1:3 title "4. builtin sine" with linespoints ls 10,\
     "${DATAFILE6}" using 1:3 title "5. texture interp" with linespoints ls 12,\
     "${DATAFILE5}" using 1:3 title "no calculation" with linespoints ls 0

EOF
