#!/bin/sh

DATAFILE=$1
IMGFILE=$2
TITLE=$3

gnuplot <<EOF
set terminal postscript enhanced eps monochrome
set output "${IMGFILE}"
set rmargin 3

set title "Kernel time: ${TITLE}"
set xlabel "Block size"
set ylabel "Duration (ms)"


set xtics (        \
  "..." 64,      \
  "" 128,          \
  "" 256,          \
  "" 512,          \
  "" 1024,         \
  "" 2048,         \
  "" 4096,   \
  "" 8192,   \
  "2^{14}" 16384,  \
  "2^{15}" 32768,  \
  "2^{16}" 65536,  \
  "2^{17}" 131072, \
  "2^{18}" 262144 )
set grid

set yrange [0:15000]
set xrange [0:131072]
#set log y 2

plot "${DATAFILE}" using 1:3 title "kernel time" with linespoints
EOF
