#!/bin/sh

for file in ../roundtrip/*.txt; do
  if [ -z "`echo ${file} | grep \"block-size\"`" ]; then
    name=`basename ${file} .txt`
    title=`echo ${name} | tr '-' ' '`
    if [ ! -z "`echo ${file} | grep -v block-period`" ]; then
      if [ ! -z "`echo ${file} | grep FFT`" ]; then 
        if [ ! -z "`echo ${file} | grep 275`" ]; then
          model=275
        else
          model=470
        fi
        ./roundtrip-fft.sh ${file} ../img/${name}.eps "${model}"
      else
        ./roundtrip-pv.sh ${file} ../img/${name}.eps "${title}"
      fi
    fi
  fi
done

for model in 275 470; do
  DATAFILE1=../roundtrip/PV-${model}-nointerp-batch.txt
  DATAFILE2=../roundtrip/PV-${model}-linear-batch.txt
  DATAFILE3=../roundtrip/PV-${model}-cubic-batch.txt
  DATAFILE4=../roundtrip/PV-${model}-builtin-batch.txt
  DATAFILE5=../roundtrip/PV-${model}-nocalc-batch.txt
  DATAFILE6=../roundtrip/PV-${model}-texture-batch.txt
  ./roundtrip-pv-interp.sh ${DATAFILE1} ${DATAFILE2} ${DATAFILE3} ${DATAFILE4} ${DATAFILE5} ${DATAFILE6} ../img/PV-${model}-1-interp.eps ${model}
  if [ "${model}" -eq "275" ]; then
    key=off
    height="0.53"
  else
    key="below horizontal"
    height="0.75"
  fi
  ./roundtrip-pv-interp.2.sh ${DATAFILE1} ${DATAFILE2} ${DATAFILE3} \
    ${DATAFILE4} ${DATAFILE5} ${DATAFILE6} ../img/PV-${model}-2-interp.eps \
    ${model} "${key}" ${height}

  # memory transfer times comparison
  DATAFILE1=../roundtrip/FFT-${model}-batch.txt
  DATAFILE2=../roundtrip/PV-${model}-cubic-batch.txt
  ./memory-comparison.sh ${DATAFILE1} ${DATAFILE2} ../img/MEM-${model}.eps "Memory transfer times (FFT and PV) - GTX ${model}"
done
