#include <stdio.h>

#include <cuda_runtime_api.h>

#include "m_pd.h"

extern "C" void get_grid_and_block(int *grid,int *block,int s_n);

__global__ void ZeroA(float* A)
{
  int i = blockDim.x * blockIdx.x + threadIdx.x;
  A[i] = 0;
}

extern "C" void cuda_zeroa_basic(t_sample *vec, int n)
{
    int grid,block;
    cudaError_t errno;
    get_grid_and_block(&grid, &block, n);
    ZeroA<<<grid,block>>>(vec);
    /*cudaThreadSynchronize();*/
    errno = cudaGetLastError();
    if (errno)
      printf("cuda error (cuda_zero_basic): %d - %s\n", (int) errno, cudaGetErrorString(errno));

}

