#include <stdio.h>

#include <cuda_runtime_api.h>
#include <cufft.h>

#include "cutil.h"
#include "m_pd.h"

extern "C" void get_grid_and_block(int *grid,int *block,int s_n);

__global__ void LogMagnitude2(cufftComplex *c, cufftReal *a)
{
  int i = blockDim.x * blockIdx.x + threadIdx.x;
  a[i] = (cufftReal) logf(sqrtf(c[i].x * c[i].x + c[i].y * c[i].y)+1);
}

extern "C" void cuda_logmagnitude2(cufftComplex *c, cufftReal *a, int n)
{
  int grid,block;
  get_grid_and_block(&grid, &block, n);
  LogMagnitude2<<<grid,block>>>(c, a);
}
