/* ajb@ime.usp.br */

#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <cuda_runtime_api.h>

#include "m_pd.h"


static t_class *cuda2_class;

typedef struct _cuda
{
  t_object x_obj;       /* obligatory header */
  t_float x_f;          /* place to hold inlet's value if it's set by message */
  t_outlet *bangoutlet; /* saida dizendo que acabou o processamento */
} t_cuda;

__global__ void square(float *a)
{
  int i = blockDim.x * blockIdx.x + threadIdx.x;
  a[i] = a[i] * a[i];
}


extern "C" t_int *cuda2_perform(t_int *w)
{
  float *h_a, *h_b, *d_a, *d_b;
  float n;
  int N = 64;
  int cuda_devicecount;

  h_a = (float *) malloc(64 * sizeof(float));
  h_b = (float *) malloc(64 * sizeof(float));
  cudaMalloc(&d_a, 64 * sizeof(float));
  cudaMalloc(&d_b, 64 * sizeof(float));

  n = 63.0;
  while (n != 0.0) {
    h_a[(int)n] = n+1;
    n -= 1.0;
  }

  n = 64.0;
  /*while (n != 0.0) {
    printf("%d: %f\n", (int)n, h_a[(int)n]);
    n -= 1.0;
  }*/

  cudaGetDeviceCount(&cuda_devicecount);
  if (cuda_devicecount)
  {
    if (!cudaSetDevice(0))
    {
      cudaMemcpy(d_a, h_a, N*sizeof(float), cudaMemcpyHostToDevice);
      cudaMemcpy(d_b, d_a, N*sizeof(float), cudaMemcpyDeviceToDevice);
      square<<<1,N>>>(d_b);
      cudaMemcpy(h_b, d_b, N*sizeof(float), cudaMemcpyDeviceToHost);
    }
  } 
  else 
    printf("Nao achei CUDA.\n");

  n = 63.0;
  while (n != 0.0) {
    if (n == 63.0)
    printf("%d: %f\n", (int)n, h_b[(int)n]);
    n -= 1.0;
  }

  free(h_a);
  cudaFree(d_a);

  return (w+6);
}

/* called to start DSP.  Here we call Pd back to add our perform
   routine to a linear callback list which Pd in turn calls to grind
   out the samples. */
static void cuda2_dsp(t_cuda *x, t_signal **sp)
{
  /*dsp_add(cuda2_perform, 5, sp[0]->s_vec, sp[1]->s_vec, sp[2]->s_vec,
  sp[0]->s_n, x);*/
}


/**
 * cuda_new(void)
 */
static void *cuda2_new(void)
{
  /*post("initializing cuda~ object.");*/

  /* init pd object */
  /*t_cuda *x = (t_cuda *)pd_new(cuda2_class);
  outlet_new(&x->x_obj, gensym("signal"));
  outlet_new(&x->x_obj, gensym("signal"));*/

  /*return (x);*/
}

/**
 * this routine, which must have exactly this name (with the "~" replaced
 * by "_tilde) is called when the code is first loaded, and tells Pd how
 * to build the "class".
 */
extern "C" void cuda2_tilde_setup(void)
{
  /*post("inicializando classe cuda~...");
  cuda2_class = class_new(gensym("cuda2~"), (t_newmethod)cuda2_new, 0,
                                  sizeof(t_cuda), 0, A_DEFFLOAT, 0);*/
  /* this is magic to declare that the leftmost, "main" inlet
     takes signals; other signal inlets are done differently...*/
  /*CLASS_MAINSIGNALIN(cuda2_class, t_cuda, x_f);*/
  /* here we tell Pd about the "dsp" method, which is called back
     when DSP is turned on. */
  /*class_addmethod(cuda2_class, (t_method)cuda2_dsp, gensym("dsp"),
  (t_atomtype) 0);*/
}
