#include <cuda_runtime_api.h>
#include <stdio.h>


__global__ void square(float *a)
{
  int i = blockDim.x * blockIdx.x + threadIdx.x;
  a[i] = a[i] * a[i];
}


int main(int argc, char *argv[])
{
  float *h_a, *d_a;
  float n;
  int N = 64;
  int cuda_devicecount;

  h_a = (float *) malloc(64 * sizeof(float));
  cudaMalloc(&d_a, 64 * sizeof(float));

  n = 63.0;
  while (n != 0.0) {
    h_a[(int)n] = n+1;
    n -= 1.0;
  }

  n = 64.0;
  while (n != 0.0) {
    printf("%d: %f\n", (int)n, h_a[(int)n]);
    n -= 1.0;
  }

  cudaGetDeviceCount(&cuda_devicecount);
  if (cuda_devicecount)
  {
    if (!cudaSetDevice(0))
    {
      cudaMemcpy(d_a, h_a, N*sizeof(float), cudaMemcpyHostToDevice);
      square<<<1,N>>>(d_a);
      cudaMemcpy(h_a, d_a, N*sizeof(float), cudaMemcpyDeviceToHost);
    }
  } 
  else 
    printf("Nao achei CUDA.\n");

  n = 63.0;
  while (n != 0.0) {
    printf("%d: %f\n", (int)n, h_a[(int)n]);
    n -= 1.0;
  }

  free(h_a);
  cudaFree(d_a);

  return 0;
}

